# all files / Github/diagram-js/lib/command/ CommandInterceptor.js

71.79% Statements 28/39
85% Branches 17/20
100% Functions 8/8
71.05% Lines 27/38

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144

    1×

    35560×

    1×

    32857×
    6325×

    1×

    115777×

    115777×
    102039×
    102039×
    102039×
    102039×

    115777×
    2256×
    2256×

    115777×

    115777×
    72492×

    115777×

    115777×

    570918×

    190306×

    1×

    1×

    9×

    115777×

    115777×

     import {
      forEach,
      isFunction,
      isArray,
      isNumber,
      isObject
    } from 'min-dash';

    var DEFAULT_PRIORITY = 1000;

    /**
     * A utility that can be used to plug-in into the command execution for
     * extension and/or validation.
     *
     * @param {EventBus} eventBus
     *
     * @example
     *
     * import inherits from 'inherits';
     *
     * import CommandInterceptor from 'diagram-js/lib/command/CommandInterceptor';
     *
     * function CommandLogger(eventBus) {
     *   CommandInterceptor.call(this, eventBus);
     *
     *   this.preExecute(function(event) {
     *     console.log('command pre-execute', event);
     *   });
     * }
     *
     * inherits(CommandLogger, CommandInterceptor);
     *
     */
    export default function CommandInterceptor(eventBus) {
      this._eventBus = eventBus;
    }

    CommandInterceptor.$inject = [ 'eventBus' ];

    function unwrapEvent(fn, that) {
      return function(event) {
        return fn.call(that || null, event.context, event.command, event);
      };
    }

    /**
     * Register an interceptor for a command execution
     *
     * @param {String|Array<String>} [events] list of commands to register on
     * @param {String} [hook] command hook, i.e. preExecute, executed to listen on
     * @param {Number} [priority] the priority on which to hook into the execution
     * @param {Function} handlerFn interceptor to be invoked with (event)
     * @param {Boolean} unwrap if true, unwrap the event and pass (context, command, event) to the
     *                          listener instead
     * @param {Object} [that] Pass context (`this`) to the handler function
     */
    CommandInterceptor.prototype.on = function(events, hook, priority, handlerFn, unwrap, that) {

      Iif (isFunction(hook) || isNumber(hook)) {
        that = unwrap;
        unwrap = handlerFn;
        handlerFn = priority;
        priority = hook;
        hook = null;
      }

      if (isFunction(priority)) {
        that = unwrap;
        unwrap = handlerFn;
        handlerFn = priority;
        priority = DEFAULT_PRIORITY;
      }

      if (isObject(unwrap)) {
        that = unwrap;
        unwrap = false;
      }

      Iif (!isFunction(handlerFn)) {
        throw new Error('handlerFn must be a function');
      }

      if (!isArray(events)) {
        events = [ events ];
      }

      var eventBus = this._eventBus;

      forEach(events, function(event) {
        // concat commandStack(.event)?(.hook)?
        var fullEvent = [ 'commandStack', event, hook ].filter(function(e) { return e; }).join('.');

        eventBus.on(fullEvent, priority, unwrap ? unwrapEvent(handlerFn, that) : handlerFn, that);
      });
    };

    var hooks = [
      'canExecute',
      'preExecute',
      'preExecuted',
      'execute',
      'executed',
      'postExecute',
      'postExecuted',
      'revert',
      'reverted'
    ];

    /*
     * Install hook shortcuts
     *
     * This will generate the CommandInterceptor#(preExecute|...|reverted) methods
     * which will in term forward to CommandInterceptor#on.
     */
    forEach(hooks, function(hook) {

      /**
       * {canExecute|preExecute|preExecuted|execute|executed|postExecute|postExecuted|revert|reverted}
       *
       * A named hook for plugging into the command execution
       *
       * @param {String|Array<String>} [events] list of commands to register on
       * @param {Number} [priority] the priority on which to hook into the execution
       * @param {Function} handlerFn interceptor to be invoked with (event)
       * @param {Boolean} [unwrap=false] if true, unwrap the event and pass (context, command, event) to the
       *                          listener instead
       * @param {Object} [that] Pass context (`this`) to the handler function
       */
      CommandInterceptor.prototype[hook] = function(events, priority, handlerFn, unwrap, that) {

        Iif (isFunction(events) || isNumber(events)) {
          that = unwrap;
          unwrap = handlerFn;
          handlerFn = priority;
          priority = events;
          events = null;
        }

        this.on(events, hook, priority, handlerFn, unwrap, that);
      };
    });